/*
**	Sybase Open Client 
**	Confidential Property of Sybase, Inc.
**	(c) Copyright Sybase, Inc. 1991 - 2004
**	All rights reserved
*/

/*
** thrdfunc.h
**
** Header file which contains the defines and prototypes for the utility
** functions in thrdfunc.c
**
*/

#ifndef	__THRDFUNC_H__
#define __THRDFUNC_H__

/* 
** prototypes for thread and synchronization routines 
*/
extern CS_RETCODE  ex_create_mutex  PROTOTYPE((
	CS_VOID **mutex
	));
extern CS_RETCODE  ex_take_mutex  PROTOTYPE((
	CS_VOID *mutex
	));
extern CS_RETCODE  ex_release_mutex  PROTOTYPE((
	CS_VOID *mutex
	));
extern CS_RETCODE  ex_delete_mutex  PROTOTYPE((
	CS_VOID *mutex
	));

extern CS_RETCODE  ex_create_sem PROTOTYPE((
	CS_VOID **semaphore,
	CS_UINT count
	));
extern CS_RETCODE  ex_release_sem PROTOTYPE((
	CS_VOID *semaphore
	));
extern CS_RETCODE  ex_waitfor_sem PROTOTYPE((
	CS_VOID *semaphore
	));
extern CS_RETCODE  ex_delete_sem PROTOTYPE((
	CS_VOID *semaphore
	));

extern CS_RETCODE  ex_create_thread PROTOTYPE((
        CS_VOID **thread,
        CS_VOID *startRoutine,
        CS_VOID *arg
        ));
extern CS_RETCODE  ex_detach_thread PROTOTYPE((
        CS_VOID *thread
	));
extern CS_VOID  ex_yield PROTOTYPE((
	));

extern CS_RETCODE  ex_create_global_mutex PROTOTYPE((
	CS_VOID
	));
extern CS_RETCODE  ex_delete_global_mutex PROTOTYPE((
	CS_VOID
	));
extern CS_RETCODE  ex_take_global_mutex PROTOTYPE((
	CS_VOID
	));
extern CS_RETCODE  ex_release_global_mutex PROTOTYPE((
	CS_VOID
	));

#endif /* __THRDFUNC_H__ */
