/* dbctutil.h */

#include <stdio.h>
#include <stdlib.h>
#include <ctpublic.h>

/*
** Define a macro for return-code error checking within the
** dbct_ routines.
*/
#if !defined(ERR_CH) 
#define ERR_CH stderr
#endif
#define DBCT_FAIL_ON_FAIL(ret, str)\
{ \
  if (ret != CS_SUCCEED) \
  { \
    fprintf(ERR_CH, "dbctutil error: %s\n", str); \
    return CS_FAIL; \
  } \
}

extern CS_CHAR * CS_PUBLIC dbct_prtype PROTOTYPE ((CS_INT datatype));

extern CS_INT CS_PUBLIC dbct_datename PROTOTYPE ((
   CS_CONTEXT  *context,
   CS_CHAR     *buf,
   CS_INT      buflen,
   CS_INT      datepart,
   CS_DATETIME *datetime ));
	       
extern CS_RETCODE CS_PUBLIC dbct_parent_ctx PROTOTYPE ((
  CS_COMMAND    *cmd,
  CS_CONNECTION *conn,
  CS_CONTEXT    **ctxptr ));

extern CS_RETCODE CS_PUBLIC dbct_parent_conn PROTOTYPE ((
  CS_COMMAND    *cmd,
  CS_CONNECTION **connptr ));

extern CS_CHAR * CS_PUBLIC dbct_trim PROTOTYPE((CS_CHAR *str));

/*
** Date part codes for dbct_datename().
*/
#define DBDATE_YY       0       /* year         1753 - 9999 */
#define DBDATE_QQ       1       /* quarter      1 - 4 */
#define DBDATE_MM       2       /* month        January - December */
#define DBDATE_DW       3       /* weekday      Monday - Sunday */
#define DBDATE_DD       4       /* day          1 - 31 */
#define DBDATE_DY       5       /* dayofyear    1 - 366 */
#define DBDATE_HH       6       /* hour         0 - 23 */
#define DBDATE_MI       7       /* minute       0 - 59 */
#define DBDATE_SS       8       /* second       0 - 59 */
#define DBDATE_MS       9       /* millisecond  0 - 999 */
#define DBDATE_WK       10      /* week         1 - 54 (for leap years) */
#define	DBDATE_CY	11
#define	DBDATE_CW	12
#define	DBDATE_CD	13
	





















